component{

	// around uniformity
	function aroundHandler(event,targetAction){
		var rc = event.getCollection();
		var prc = event.getCollection(private=true);
		// json is default format
		event.paramValue("format","json");
		if( NOT reFindNoCase("^(xml|json)$",rc.format) ){
			throw(message="Invalid request format sent: #rc.format#",detail="Valid formats are json and xml",type="Relax.IvalidResponseType");
		}
		// log incoming request
		log.debug("Incoming request for route: #event.getCurrentRoute()#", getHTTPRequestData());
		// prepare results
		prc.results = prepareResults();
		// execute action
		arguments.targetAction(event,rc,prc);
		// render data
		event.renderData(data=prc.results,type=rc.format);
		// log outgoig request
		log.debug("Outgoing response for route: #event.getCurrentRoute()#", prc.results);
	}
	
	// on error uniformity
	function onError(event,faultAction,exception){
		var rc	= event.getCollection();
		// prepare error structures
		rc.results.error	 = true;
		rc.results.messages = "The action:#faultaction# failed:                                 #exception.detail# #exception.message#";
		
		// log error
		log.error(rc.results.messages, exception);
		
		// Headers
		event.setHTTPHeader(500,rc.results.messages)
			.renderData(data=rc.results,type="json");
	}
	
	
	// prepare results
	private function prepareResults(){
		var results = {
			error 		= false,
			messages 	= "",
			data 		= ""
		};	
		return results;
	}
}


